<template>
  <div>
    <section
      id="project-img"
      class="project-img games-page"
      style="padding-bottom: 20px"
    >
      <div style="padding: 0px">
        <div class="justify-content-center text-center">
          <a-banner
            v-if="type == 'inicio'"
            category="banner loteria resultados"
          ></a-banner>
          <a-banner
            v-if="type == 'compra_tus_juegos'"
            category="banner loteria compra de boletos"
          ></a-banner>
        </div>
      </div>
      <div
        class="row justify-content-center text-center"
        style="padding: 0px; margin: 0px"
      >
        <div
          class="row justify-content-center text-center"
          style="max-width: 1227px"
        >
          <div style="padding: 0 2px 0 2px; width: 65.35%">
            <a-banner
              v-if="type == 'inicio'"
              category="banner loteria resultados left"
            ></a-banner>
            <a-banner
              v-if="type == 'compra_tus_juegos'"
              category="banner loteria compra de boletos left"
            ></a-banner>
          </div>
          <div style="padding: 0 2px 0 2px; width: 34.42%">
            <a-banner
              v-if="type == 'inicio'"
              category="banner loteria resultados right"
            ></a-banner>
            <a-banner
              v-if="type == 'compra_tus_juegos'"
              category="banner loteria compra de boletos right"
            ></a-banner>
          </div>
        </div>
      </div>
      <div
        class="row justify-content-center text-center"
        style="padding-top: 20px"
      >
        <iframe
          id="iframeRef"
          :src="url"
          width="100%"
          framespacing="0"
          border="0"
          frameborder="0"
          scrolling="yes"
          style="max-width: 1220px; box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25)"
        ></iframe>
      </div>
      <div style="padding: 0px" v-if="type == 'inicio'">
        <div class="row justify-content-center text-center">
          <div class="banner-games desktopimage">
            <div
              class="row mx-0"
              style="
                justify-content: space-evenly;
                padding-top: 8px;
                align-items: center;
              "
            >
              <game-banner
                v-for="item in gamesAll"
                :key="item.gameID"
                :title="item.name"
                :category="item.category"
                :imgpath="item.thumbnailPath"
                :playlink="item.playLinkDemo"
                :gameid="item.gameID"
                :isnew="item.new"
                :params="item.gameParams"
                @login="$emit('login')"
                @balance="goToPlay(item.gameID)"
              >
              </game-banner>
            </div>
          </div>
        </div>
        <div class="row justify-content-center text-center">
          <div class="desktopimage">
            <a-banner
              v-if="isDesktop()"
              category="banner loteria footer"
            ></a-banner>
            <div
              class="row justify-content-center text-center"
              style="max-width: 1227px"
            >
              <div class="col-6" style="padding: 0 2px 0 2px !important">
                <a-banner
                  v-if="isDesktop()"
                  category="banner loteria footer left"
                ></a-banner>
              </div>
              <div class="col-6" style="padding: 0 2px 0 2px !important">
                <a-banner
                  v-if="isDesktop()"
                  category="banner loteria footer right"
                ></a-banner>
              </div>
            </div>
          </div>
          <div class="mobileimage">
            <a-banner
              v-if="!isDesktop()"
              category="banner loteria footer (mobile)"
            ></a-banner>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
module.exports = {
  props: ["type"],
  mixins: [common],
  data() {
    return {
      url: null,
      contents: [],
      gamesAll: null,
    };
  },
  mounted() {
    this.initFrame();
    this.resizeFrame();
    if (this.type == "inicio") this.getGames();
  },
  beforeDestroy() {
    document.removeEventListener("scroll", this.postMessageIFrame, false);
  },
  methods: {
    initFrame() {
      let token =
        this.isUserLogged() && !this.isUserSelfexcluded()
          ? "?token=" + store.state.loteriatoken
          : "";

      if (this.type == "inicio") {
        this.url = store.state.loteriaUrlLandingPage + token; //this.url = "loteria_test#/prj_inicio" + token;
      } else if (this.type == "compra_tus_juegos")
        this.url = store.state.loteriaUrlSalesPage + token;
      //this.url = "loteria_test#/prj_compra_tus_juegos" + token;
      else router.push("/not-found");

      let eventMethod = window.addEventListener
        ? "addEventListener"
        : "attachEvent";
      let eventer = window[eventMethod];
      let messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";

      // Listen to message from child window
      eventer(
        messageEvent,
        (e) => {
          let key = e.message ? "message" : "data";
          let data = e[key];
          if (data === "getBalance") {
            console.log("messageEvent balance called");
            this.$emit("balance");
          }
        },
        false
      );

      // capture scrolling
      document.addEventListener("scroll", this.postMessageIFrame, false);
    },
    postMessageIFrame() {
      let iFrame = document.getElementById("iframeRef");
      if (iFrame)
        iFrame.contentWindow.postMessage(
          {
            message: "scrolling",
            top: document.documentElement.scrollTop,
            screen: window.innerHeight,
          },
          "*"
        );
    },
    resizeFrame() {
      iFrameResize(
        {
          log: false,
          checkOrigin: false,
          heightCalculationMethod: "lowestElement",
          minHeight: 300,
        },
        "#iframeRef"
      );
    },
    getGames() {
      this.loading = true;
      this.$http
        .get("games-banner")
        .then((response) => {
          this.gamesAll = response.data.gamesAll;
        })
        .catch((response) => {
          this.showError(response, this.getLocate("game-list-1"));
        })
        .finally(() => {
          this.loading = false;
        });
    },
    goToPlay(gameId) {
      location.href = "#/juegos/play/" + gameId;
    },
  },
};
</script>